tests: invoke full_cleanup from script trap handlers, use modprobe -r
[lttng-tools.git] / tests / regression / tools / streaming / test_high_throughput_limits
index b2c8864cafc6c0d70a8f1d2727fd271748f9b255..1bcf35328691e7807a51523374bab2a097f40b9d 100755 (executable)
@@ -33,7 +33,7 @@ DEFAULT_IF="lo"
 
 TRACE_PATH=$(mktemp -d)
 
-NUM_TESTS=112
+NUM_TESTS=104
 
 source $TESTDIR/utils/utils.sh
 
@@ -41,6 +41,12 @@ if [ ! -x "$TESTAPP_BIN" ]; then
        BAIL_OUT "No UST events binary detected."
 fi
 
+function reset_bw_limit
+{
+       tc qdisc del dev $DEFAULT_IF root >/dev/null 2>&1
+       return $?
+}
+
 function set_bw_limit
 {
        limit=$1
@@ -51,28 +57,47 @@ function set_bw_limit
        # parent qdisc (1:) will always limit us to the right max value
        dataportlimit=$((9*${ctrlportlimit}))
 
+       diag "Set bandwidth limits to ${limit}kbits, ${ctrlportlimit} for control and ${dataportlimit} for data"
 
        tc qdisc add dev $DEFAULT_IF root handle 1: htb default 15 >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
 
        # the total bandwidth is the limit set by the user
        tc class add dev $DEFAULT_IF parent 1: classid 1:1 htb rate ${limit}kbit ceil ${limit}kbit >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
        # 1/10 of the bandwidth guaranteed and traffic prioritized for the control port
        tc class add dev $DEFAULT_IF parent 1:1 classid 1:10 htb rate ${ctrlportlimit}kbit ceil ${limit}kbit prio 1 >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
        # 9/10 of the bandwidth guaranteed and can borrow up to the total bandwidth (if unused)
        tc class add dev $DEFAULT_IF parent 1:1 classid 1:11 htb rate ${dataportlimit}kbit ceil ${limit}kbit prio 2 >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
 
        # filter to assign control traffic to the 1:10 class
        tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_CTRL_PORT 0xffff flowid 1:10 >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
        # filter to assign data traffic to the 1:11 class
        tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_DATA_PORT 0xffff flowid 1:11 >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
 
-       ok $? "Set bandwidth limits to ${limit}kbits, ${ctrlportlimit} for control and ${dataportlimit} for data"
-}
-
-function reset_bw_limit
-{
-       tc qdisc del dev $DEFAULT_IF root >/dev/null 2>&1
-       ok $? "Reset bandwith limits"
+       return 0
 }
 
 function create_lttng_session_with_uri
@@ -95,24 +120,18 @@ function run_apps
        done
 }
 
-function wait_apps
-{
-       while [ -n "$(pidof $TESTAPP_NAME)" ]; do
-               sleep 1
-       done
-       pass "Wait for applications to end"
-}
-
 function test_high_throughput
 {
        NETWORK_URI="net://localhost"
        create_lttng_session_with_uri $SESSION_NAME $NETWORK_URI
-       enable_ust_lttng_event $SESSION_NAME $EVENT_NAME
-       start_lttng_tracing $SESSION_NAME
+       enable_ust_lttng_event_ok $SESSION_NAME $EVENT_NAME
+       start_lttng_tracing_ok $SESSION_NAME
        run_apps
-       wait_apps
-       stop_lttng_tracing $SESSION_NAME
-       destroy_lttng_session $SESSION_NAME
+       diag "Waiting for applications to end"
+       wait
+       pass "waiting done"
+       stop_lttng_tracing_ok $SESSION_NAME
+       destroy_lttng_session_ok $SESSION_NAME
        validate_event_count
 }
 
@@ -154,10 +173,9 @@ function validate_event_count
 function interrupt_cleanup()
 {
        diag "*** Exiting ***"
-       stop_lttng_relayd
-       stop_lttng_sessiond
        reset_bw_limit
-       exit 1
+       # invoke utils cleanup
+       full_cleanup
 }
 
 plan_tests $NUM_TESTS
@@ -174,13 +192,15 @@ skip $isroot "Root access is needed to set bandwith limits. Skipping all tests."
 {
 
        # Catch sigint and try to cleanup limits
-       trap interrupt_cleanup SIGINT
+       trap interrupt_cleanup SIGTERM SIGINT
 
        BW_LIMITS=(3200 1600 800 400 200 100 50 25)
        for BW in ${BW_LIMITS[@]};
        do
                diag "Test high-throughput with bandwidth limit set to ${BW}kbits"
+
                set_bw_limit $BW
+               ok $? "Setting bandwidth limit"
 
                start_lttng_sessiond
                start_lttng_relayd "-o $TRACE_PATH"
@@ -189,5 +209,6 @@ skip $isroot "Root access is needed to set bandwith limits. Skipping all tests."
                stop_lttng_relayd
                stop_lttng_sessiond
                reset_bw_limit
+               ok $? "Reset bandwith limits"
        done
 }
This page took 0.025584 seconds and 5 git commands to generate.